Poj3126
Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 16201 | Accepted: 9151 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
Source
大致题意:
给定两个四位素数a b,要求把a变换到b
变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数 只能有一个位不同,而且每步得到的素数都不能重复。
求从a到b最少需要的变换次数。无法变换则输出Impossible
思路:Eratosthenes筛法+bfs
#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #include<queue> using namespace std; #define N 10010 int prime[N],a[N],vis[N]; int time,tot; int n=10000,m,p; struct node{ int value; int deep; }; bool hd(int n,int m){//判断只差一位 int sum=0; int temp1,temp2; while(n!=0){ temp1=n%10; temp2=m%10; if(temp1!=temp2) sum++; n/=10; m/=10; } if(sum==1) return true; return false; } inline int bfs(){ memset(vis,0,sizeof vis); queue<node>que; node now,next; now.deep=0; vis[now.value=n]=1; que.push(now); while(!que.empty()){ now=que.front(); que.pop(); if(now.value==m){ time=now.deep;//记录 return 1; } for(int i=tot;i>=1;i--){ if(!vis[prime[i]]&&hd(prime[i],now.value)){ vis[prime[i]]=1; next.value=prime[i]; next.deep=now.deep+1; que.push(next); } } } return 0; } int main(){ int t;//prime[]存1000-9999的素数 for(int i=2;i<=n;i++) if(!vis[i]){ a[tot++]=i; for(int j=i*2;j<=n;j+=i) vis[j]=1; } for(int i=0;i<tot;i++) if(a[i]>1000) prime[++p]=a[i]; scanf("%d",&t); while(t--){ scanf("%d%d",&n,&m); if(bfs()) printf("%d\n",time); else printf("Impossible\n"); } return 0; }